;;;=================================================================
;;;
;;; RINS.LSP V3.20
;;;
;;; Redfinir le point d'insertion des blocs
;;;
;;; Copyright (C) Patrick_35
;;;
;;;=================================================================

(defun c:rins(/ *errins* att bl dec deh doc ech ent js n nom nom_bl lst1 lst2 pt rep rota s uni)

  (defun *errins* (msg)
    (or (member (strcase msg) '("FUNCTION CANCELLED" ""QUIT / EXIT ABORT"" "FONCTION ANNULEE" "QUITTER / SORTIR ABANDON"))
      (princ (strcat "\nErreur : " msg))
    )
    (vla-endundomark doc)
    (setq *error* s)
    (princ)
  )

  (defun rota(pt bas rot / lay lck po)
    (setq lay (vla-item (vla-get-layers doc) (getvar "clayer")))
    (and (eq (vla-get-lock lay) :vlax-true)
      (setq lck T)
      (vla-put-lock lay :vlax-false)
    )
    (setq po (vla-addpoint (if (eq (getvar "cvport") 1)
			     (vla-get-paperspace doc)
			     (vla-get-modelspace doc)
			   )
			   (vlax-3d-point pt)
	     )
    )
    (vla-rotate po (vlax-3d-point bas) rot)
    (setq pt (vlax-get po 'coordinates))
    (vla-delete po)
    (and lck (vla-put-lock lay :vlax-true))
    pt
  )

  (defun nom_bl(bl)
    (if (vlax-property-available-p bl 'effectivename)
      (vla-get-effectivename bl)
      (vla-get-name bl)
    )
  )

  (vl-load-com)
  (setq doc (vla-get-activedocument (vlax-get-acad-object))
	s *error*
	*error* *errou*
  )
  (vla-startundomark doc)
  (if (ssget (list (cons 0 "INSERT")))
    (progn
      (vlax-for bl (setq js (vla-get-activeselectionset doc))
	(or (member (setq nom (nom_bl bl)) lst2)
	  (setq lst1 (cons bl lst1)
		lst2 (cons nom lst2)
	  )
	)
      )
      (vla-delete js)
      (initget "Oui Non _Yes _No")
      (setq rep (getkword "\nDsirez-vous conserver l'emplacement actuel des blocs <O> : "))
      (or rep
	(setq rep "Oui")
      )
      (foreach ent (reverse lst1)
	(vla-highlight ent :vlax-true)
	(while (not (setq pt (getpoint "\nVeuillez slectionner son nouveau point de base : "))))
	(vla-highlight ent :vlax-false)
	(setq bl  (vla-item (vla-get-blocks doc) (setq nom (nom_bl ent)))
	      dec (mapcar '- (rota (trans pt 1 0) (vlax-get ent 'insertionpoint) (- (vlax-get ent 'rotation))) (vlax-get ent 'insertionpoint))
	)
	(if (< (vlax-get ent 'xscalefactor) 0)
	  (setq dec (list (- (car dec)) (cadr dec) (caddr dec)) dea dec)
	)
	(setq deh (mapcar '/ dec (list (abs (vlax-get ent 'xscalefactor)) (abs (vlax-get ent 'yscalefactor)) (abs (vlax-get ent 'zscalefactor)))))
	(vlax-put bl 'origin (mapcar '+ (vlax-get bl 'origin) deh))
	(if (ssget "x" (list (cons 0 "INSERT") (cons 2 (strcat nom ",`**"))))
	  (progn
	    (vlax-for ent (setq js (vla-get-activeselectionset doc))
	      (and (eq rep "Oui") (eq (strcase (nom_bl ent)) (strcase nom))
		(progn
		  (setq att (mapcar '(lambda(x) (cons (vlax-get x 'insertionpoint) x)) (vlax-invoke ent 'getattributes))
			ech (list (vlax-get ent 'xscalefactor)
				  (vlax-get ent 'yscalefactor)
				  (vlax-get ent 'zscalefactor)
			    )	
			dec (mapcar '*	(rota deh '(0.0 0.0 0.0) (vlax-get ent 'rotation))
					(list (vlax-get ent 'xscalefactor)
					      (vlax-get ent 'yscalefactor)
					      (vlax-get ent 'zscalefactor)
					)
			    )
		  )
		  (vla-move ent (vlax-3d-point '(0.0 0.0 0.0)) (vlax-3d-point dec))
		  (and att (mapcar '(lambda(x)(vlax-invoke (cdr x) 'move (vlax-get (cdr x) 'insertionpoint) (car x))) att))
		)
	      )
	    )
	    (vla-delete js)
	    (princ (strcat "\nModification du point de base pour le bloc \"" nom "\" effectu."))
	  )
	)
      )
    )
    (princ "\nPas de bloc de slectionn.")
  )
  (vla-endundomark doc)
  (setq *error* s)
  (princ)
)

(setq nom_lisp "RINS")
(if (/= app nil)
  (if (= (strcase (substr app (1+ (- (strlen app) (strlen nom_lisp))) (strlen nom_lisp))) nom_lisp)
    (princ (strcat "..." nom_lisp " charg."))
    (princ (strcat "\n" nom_lisp ".LSP Charg.....Tapez " nom_lisp " pour l'xecuter.")))
  (princ (strcat "\n" nom_lisp ".LSP Charg......Tapez " nom_lisp " pour l'xecuter.")))
(setq nom_lisp nil)
(princ)